> You are reading the Docusign Developer Documentation. For clean Markdown of any page, append .md to the page URL.
>
> Documentation indexes by section:
> - APIs and SDKs: https://docusign.docs.buildwithfern.com/docs/llms.txt
> - Platform 101: https://docusign.docs.buildwithfern.com/platform/llms.txt
> - Extension Apps: https://docusign.docs.buildwithfern.com/extension-apps/llms.txt
> - Docusign CLI: https://docusign.docs.buildwithfern.com/docusign-cli/llms.txt
>
> Authentication (OAuth, JWT Grant, M2M): https://docusign.docs.buildwithfern.com/platform/auth
> Webhooks and Connect: https://docusign.docs.buildwithfern.com/platform/webhooks
>
> OpenAPI specifications: https://docusign.docs.buildwithfern.com/openapi.json
> MCP server: https://docusign.docs.buildwithfern.com/_mcp/server

# How to get a list of elastic templates

> Demonstrates how to use the Click API to get a list of elastic templates associated with a specific Docusign user.

This topic demonstrates how to use the Click API to get a list of elastic templates associated with a specific Docusign user.

**Note**: If this is the first time you are using the Click API, we recommend creating one or more elastic templates using the Docusign web UI first, then using the Click API to get a list of those elastic templates. After you are familiar with how the Click API works, you can use it to create elastic templates so you no longer need to create them manually. This approach makes it easier to troubleshoot by eliminating some factors and simplifying your first API call. To use the Docusign web UI to manually create elastic templates, see [Create an Elastic Template](https://support.docusign.com/s/document-item?bundleId=igo1666647424726\&topicId=vxi1572482718750.html) in the user guide.

> **Note**
>
> Run this code example from our [Quickstart](/docs/esign-rest-api/quickstart) or launcher projects: [Bash](https://github.com/docusign/code-examples-bash), [C#](https://github.com/docusign/code-examples-csharp), [Java](https://github.com/docusign/code-examples-java), [Node.js](https://github.com/docusign/code-examples-node), [PHP](https://github.com/docusign/code-examples-php), [PowerShell](https://github.com/docusign/code-examples-powershell), [Python](https://github.com/docusign/code-examples-python), or [Ruby](https://github.com/docusign/code-examples-ruby).

## Required data

Running the code in this how-to requires this data:

| Data element                  | Description                                                                                                                                                                                                                                                                                                             |
| ----------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| \{API_ACCOUNT_ID}             | A [GUID](http://guid.one/) value that identifies your account. This value is automatically generated by Docusign for any account you create. Copy the value from the **API Account ID** field on the [Apps and Keys](https://admindemo.docusign.com/authenticate?goTo=appsAndKeys) page.                                |
| \{BASE_PATH}                  | A string value that forms the root of the URL required to make API calls. The base path value in the example code is set to target the developer environment at https\://\<domain>/clickapi Where \<domain> is demo.docusign.net for the developer environment and is the result of the GetUserInfo call in production. |
| One or more elastic templates | Your user account must have at least one elastic template to retrieve.                                                                                                                                                                                                                                                  |

## Step 1. Obtain your OAuth token

To make the API call shown in this how-to, you need a valid OAuth access token. Docusign supports access tokens for three different recommended OAuth grant types: Public Authorization Code Grant, Confidential Authorization Code Grant, and JSON Web Token (JWT) Grant. Choose the OAuth grant type appropriate for your scenario.

> **Note**
>
> See [Authentication](/docs/click-api/click101/auth) for guidance on your options to get an OAuth token.

![Three icons that represent the three methods a user can use to obtain an OAuth token: JSON Web Token (JWT), Public Authorization Code Grant (ACG), and Confidential Authorization Code grant](/_fern-files/_img/64f473773042ee439449a096bf7673292b1585b86a4ccc55f82ba0dda41f61a1.webp)

## Step 2. Construct your API headers

After you have a valid OAuth access token, you are ready to construct the API headers that you will pass to the API call. Construct your headers like this, but make sure to substitute your valid OAuth access token for \{ACCESS_TOKEN}.

**`Bash`**

```bash title="Bash"
declare -a Headers=('--header' "Authorization: Bearer ${ACCESS_TOKEN}"
    '--header' "Accept: application/json")
```

**`C#`**

```csharp title="C#"
var docuSignClient = new DocuSignClient(basePath);
docuSignClient.Configuration.DefaultHeader.Add("Authorization", "Bearer " + accessToken);
```

**`Java`**

```java title="Java"
ApiClient apiClient = new ApiClient(basePath);
apiClient.addDefaultHeader(HttpHeaders.AUTHORIZATION, BEARER_AUTHENTICATION + userAccessToken);
apiClient.addAuthorization("docusignAccessCode", new OAuth());
return apiClient;
```

**`Node.js`**

```javascript title="Node.js"
const dsApiClient = new docusignClick.ApiClient();
dsApiClient.setBasePath(args.basePath);
dsApiClient.addDefaultHeader('Authorization', 'Bearer ' + args.accessToken);
```

**`PHP`**

```php title="PHP"
$config = new Configuration();
$config->setHost('https://demo.docusign.net/clickapi');
$config->addDefaultHeader('Authorization', 'Bearer ' . $args['ds_access_token']);
$this->apiClient = new ApiClient($config);
```

**`PowerShell`**

```text title="PowerShell"
$headers = New-Object "System.Collections.Generic.Dictionary[[String],[String]]"
$headers.add("Authorization", "Bearer $accessToken")
$headers.add("Accept", "application/json")
$headers.add("Content-Type", "application/json")
```

**`Python`**

```python title="Python"
api_client = create_click_api_client(
    access_token=args["access_token"]
)
```

**`Ruby`**

```ruby title="Ruby"
configuration = DocuSign_Click::Configuration.new
configuration.host = args[:base_path]

api_client = DocuSign_Click::ApiClient.new configuration
api_client.set_default_header('Authorization', "Bearer #{args[:access_token]}")
```

## Step 3. Call the Click API

Now that you’ve constructed your API headers, make a request to the [Clickwraps:getClickwraps](/docs/click-api/reference/accounts/clickwraps/getclickwraps) method to retrieve all elastic templates for your account. Here’s how you make the call, but make sure to substitute your API account ID for \{ACCOUNT_ID}.

**Note:** For compatibility with previous versions of the Click API, elastic templates use clickwrap endpoints.

> **Note**
>
> View the source code for this how-to on GitHub: [Bash](https://github.com/docusign/code-examples-bash/blob/master/examples/Click/eg004GetListOfClickwraps.sh), [C#](https://github.com/docusign/code-examples-csharp/blob/master/launcher-csharp/Click/Examples/RetrieveClickwraps.cs), [Java](https://github.com/docusign/code-examples-java/blob/master/src/main/java/com/docusign/controller/click/services/GetListClickwrapsService.java), [Node.js](https://github.com/docusign/code-examples-node/blob/master/lib/click/examples/listClickwraps.js), [PHP](https://github.com/docusign/code-examples-php/blob/master/src/Services/Examples/Click/GetClickwrapsService.php), [PowerShell](https://github.com/docusign/code-examples-powershell/blob/main/examples/Click/eg004GetListOfClickwraps.ps1), [Python](https://github.com/docusign/code-examples-python/blob/master/app/click/examples/eg004_list_clickwraps.py), or [Ruby](https://github.com/docusign/code-examples-ruby/blob/main/app/services/clickwrap/eg004_list_clickwraps_service.rb)

**`Bash`**

```bash title="Bash"
curl --request GET https://demo.docusign.net/clickapi/v1/accounts/${account_id}/clickwraps \
    "${Headers[@]}" \
    --output ${response}
```

**`C#`**

```csharp title="C#"
var clickAccountApi = new AccountsApi(docuSignClient);

var response = clickAccountApi.GetClickwrapsWithHttpInfo(accountId);

response.Headers.TryGetValue("X-RateLimit-Remaining", out string remaining);
response.Headers.TryGetValue("X-RateLimit-Reset", out string reset);

if (reset != null && remaining != null)
{
    DateTime resetDate = DateTimeOffset.FromUnixTimeSeconds(long.Parse(reset)).UtcDateTime;
    Console.WriteLine("API calls remaining: " + remaining);
    Console.WriteLine("Next Reset: " + resetDate);
}

return response.Data;
```

**`Java`**

```java title="Java"
ApiResponse<ClickwrapVersionsResponse> response = accountsApi.getClickwrapsWithHttpInfo(accountId,
        (GetClickwrapsOptions) null);

Map<String, List<String>> headers = response.getHeaders();
List<String> remaining = headers.get("X-RateLimit-Remaining");
List<String> reset = headers.get("X-RateLimit-Reset");

if (remaining != null & reset != null) {
    Instant resetInstant = Instant.ofEpochSecond(Long.parseLong(reset.get(0)));
    System.out.println("API calls remaining: " + remaining);
    System.out.println("Next Reset: " + resetInstant);
}

return response.getData();
```

**`Node.js`**

```javascript title="Node.js"
const accountApi = new docusignClick.AccountsApi(dsApiClient);

// Get a list of all elastic templates
const result = await new Promise((resolve, reject) => {
    accountApi.getClickwraps(args.accountId,
    (err, data, response) => {
        if (err) return reject(err);
        resolve({ data, response });
      });
    });

  const headers = result.response.headers;
  const remaining = headers['x-ratelimit-remaining'];
  const reset = headers['x-ratelimit-reset'];

  if (remaining && reset) {
    const resetInstant = new Date(Number(reset) * 1000);
    console.log(`API calls remaining: ${remaining}`);
    console.log(`Next Reset: ${resetInstant.toISOString()}`);
  }
return result.data;
};
```

**`PHP`**

```php title="PHP"
$accountsApi = $clientService->accountsApi();
$options = new GetClickwrapsOptions();
$clickwrapVersionsResponse = $accountsApi->getClickwrapsWithHttpInfo($args['account_id'], $options);

$remaining = $clickwrapVersionsResponse[2]['X-RateLimit-Remaining'] ?? null;
$reset = $clickwrapVersionsResponse[2]['X-RateLimit-Reset'] ?? null;

if ($remaining !== null && $reset !== null) {
    $resetInstant = (new DateTime())->setTimestamp((int)$reset);
    error_log("API calls remaining: $remaining");
    error_log("Next Reset: " . $resetInstant->format(\DateTime::ATOM));
}
```

**`PowerShell`**

```text title="PowerShell"
$uri = "https://demo.docusign.net/clickapi/v1/accounts/$APIAccountId/clickwraps"
$result = Invoke-WebRequest -headers $headers -Uri $uri -UseBasicParsing -Method GET
Write-Output "Response: "
$result.Content
```

**`Python`**

```python title="Python"
accounts_api = AccountsApi(api_client)
(response, status, headers) = accounts_api.get_clickwraps_with_http_info(
    account_id=args["account_id"]
)

remaining = headers.get("X-RateLimit-Remaining")
reset = headers.get("X-RateLimit-Reset")

if remaining is not None and reset is not None:
    reset_date = dt.fromtimestamp(int(reset), tz=timezone.utc)
    print(f"API calls remaining: {remaining}")
    print(f"Next Reset: {reset_date}")
```

**`Ruby`**

```ruby title="Ruby"
accounts_api = DocuSign_Click::AccountsApi.new(api_client)
results, _status, headers = accounts_api.get_clickwraps_with_http_info(
  args[:account_id]
)

remaining = headers['X-RateLimit-Remaining']
reset = headers['X-RateLimit-Reset']

if remaining && reset
  reset_date = Time.at(reset.to_i).utc
  puts "API calls remaining: #{remaining}"
  puts "Next Reset: #{reset_date}"
end
```

## Expected response

If you run this code example from our Quickstart or launcher projects, you should see a JSON response similar to the code shown.

**`Sample response`**

```json title="Sample response"
{
  "clickwraps": [
    {
      "accountId": "a56df5fc-xxxx-xxxx-xxxx-f64dc8ab421e",
      "clickwrapId": "66a85a21-xxxx-xxxx-xxxx-6f9dd48c8483",
      "clickwrapName": "Terms of Service",
      "versionId": "890bde8b-xxxx-xxxx-xxxx-9b8e3e368834",
      "versionNumber": 2,
      "status": "inactive",
      "createdTime": "2020-08-04T21:31:04.7798287Z",
      "lastModified": "2020-08-04T21:31:04.7798287Z",
      "lastModifiedBy": "c1c4ca80-xxxx-xxxx-xxxx-32a3a9b13925",
      "requireReacceptance": true,
      "ownerUserId": "c1c4ca80-xxxx-xxxx-xxxx-32a3a9b13925"
    },
    {
      "accountId": "a56df5fc-xxxx-xxxx-xxxx-f64dc8ab421e",
      "clickwrapId": "66a85a21-xxxx-xxxx-xxxx-6f9dd48c8483",
      "clickwrapName": "Terms of Service",
      "versionId": "f19f1935-xxxx-xxxx-xxxx-fe8d93d78815",
      "versionNumber": 1,
      "status": "active",
      "createdTime": "2020-08-03T18:20:35.7848896Z",
      "lastModified": "2020-08-04T18:06:23.4715478Z",
      "lastModifiedBy": "c1c4ca80-xxxx-xxxx-xxxx-32a3a9b13925",
      "requireReacceptance": true,
      "ownerUserId": "c1c4ca80-xxxx-xxxx-xxxx-32a3a9b13925"
    }
  ],
  "page": 0,
  "pageSize": 40,
  "minimumPagesRemaining": 0
}
```

## Next steps

* Run this code example from our [Quickstart](/docs/esign-rest-api/quickstart) or launcher projects:    [Bash](https://github.com/docusign/code-examples-bash), [C#](https://github.com/docusign/code-examples-csharp), [Java](https://github.com/docusign/code-examples-java), [Node.js](https://github.com/docusign/code-examples-node), [PHP](https://github.com/docusign/code-examples-php), [PowerShell](https://github.com/docusign/code-examples-powershell), [Python](https://github.com/docusign/code-examples-python), or [Ruby](https://github.com/docusign/code-examples-ruby).
* Learn [How to create an elastic template](/docs/click-api/how-to/create-elastic-templates).
* See details on [How to activate an elastic template](/docs/click-api/how-to/activate-elastic-template).
* See how to [Go-Live](/docs/click-api/go-live) with a completed app and find the base path for API calls in the production environment.